
import java.util.*;
import java.io.*;
import junit.framework.*;
import parser.ExpressionParser;
import parser.ExpressionParser.Root;
import parser.ExpressionParser.Node;
import parser.ExpressionParser.Token;

public class Example_Test extends TestCase {
    public Example_Test(String name) {
        super(name);
    }
    
    private String expressionImage = "1 + 2 * 3 + 4 / (5 - 6)";
    private int value = 1 + 2 * 3 + 4 / (5 - 6);
    
    public void test1() throws ExpressionParser.ParseException {
        ExpressionParser.Root root = new ExpressionParser().parseRoot("test", expressionImage, 8);
        assertTrue(getImage(root).equals(expressionImage));
        int result = Example1.evaluate(root.expression());
        assertTrue(result == value);
    }
    
    public void test2() throws ExpressionParser.ParseException {
        Root root = new Example2().parseRoot("test", expressionImage, 8);
        Example2.Expression expression = (Example2.Expression) root.expression();
        int result = expression.evaluate();
        assertTrue(result == value);
    }
    
    private String getImage(Node node) {
        StringBuffer result = new StringBuffer();
        getImage(node, result);
        return result.toString();
    }
    private void getImage(Node node, StringBuffer result) {
        if (node instanceof Token) {
            result.append(((Token) node).getOriginalImage());
        } else {
            Iterator it = node.getChildNodes().iterator();
            while (it.hasNext()) {
                Node child = (Node) it.next();
                getImage(child, result);
            }
        }
    }
}
